# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`kubeinstall`](#kubeinstall): A short summary of the purpose of this class
* [`kubeinstall::calico::calicoctl`](#kubeinstallcalicocalicoctl): Installing calicoctl as a binary on a single host
* [`kubeinstall::calico::veth_mtu`](#kubeinstallcalicoveth_mtu): Configure Calico MTU
* [`kubeinstall::cluster`](#kubeinstallcluster): Cluster resources definition, export and import
* [`kubeinstall::etcd::backup`](#kubeinstalletcdbackup): Backing up an etcd cluster
* [`kubeinstall::install`](#kubeinstallinstall): A short summary of the purpose of this class
* [`kubeinstall::install::calico`](#kubeinstallinstallcalico): Install Project Calico CNI service
* [`kubeinstall::install::controller`](#kubeinstallinstallcontroller): kubernetes installation on controller node
* [`kubeinstall::install::dashboard`](#kubeinstallinstalldashboard): Install Kubernetes dashboard
* [`kubeinstall::install::helm`](#kubeinstallinstallhelm): Helm client installation
* [`kubeinstall::install::helm_binary`](#kubeinstallinstallhelm_binary): Helm client installation
* [`kubeinstall::install::node`](#kubeinstallinstallnode): A short summary of the purpose of this class
* [`kubeinstall::install::worker`](#kubeinstallinstallworker): Kubernetes installation on worker node
* [`kubeinstall::kubeadm::config`](#kubeinstallkubeadmconfig): A short summary of the purpose of this class
* [`kubeinstall::kubeadm::init_command`](#kubeinstallkubeadminit_command): A short summary of the purpose of this class
* [`kubeinstall::kubeadm::join_command`](#kubeinstallkubeadmjoin_command): Kubernetes kubeadm join command
* [`kubeinstall::kubeadm::join_config`](#kubeinstallkubeadmjoin_config): Kubernetes kubeadm join command configuration
* [`kubeinstall::params`](#kubeinstallparams): A short summary of the purpose of this class
* [`kubeinstall::profile::controller`](#kubeinstallprofilecontroller): Kubernetes conntroller setup
* [`kubeinstall::profile::kubernetes`](#kubeinstallprofilekubernetes): Base setup for any kubernetes node
* [`kubeinstall::profile::worker`](#kubeinstallprofileworker): A short summary of the purpose of this class
* [`kubeinstall::repos`](#kubeinstallrepos): Setup Kubernetes repositories
* [`kubeinstall::repos::crio`](#kubeinstallreposcrio): CRI-O repository setup
* [`kubeinstall::runtime`](#kubeinstallruntime): Kubernetes CRI setup
* [`kubeinstall::runtime::crio`](#kubeinstallruntimecrio): CRI-O container runtime installation
* [`kubeinstall::runtime::crio::config`](#kubeinstallruntimecrioconfig): CRI-O configuration file setup
* [`kubeinstall::runtime::crio::install`](#kubeinstallruntimecrioinstall): CRI-O packages installation
* [`kubeinstall::runtime::crio::service`](#kubeinstallruntimecrioservice): CRI-O service management
* [`kubeinstall::runtime::docker`](#kubeinstallruntimedocker): Docker container runtime setup
* [`kubeinstall::service`](#kubeinstallservice): A short summary of the purpose of this class
* [`kubeinstall::service::stop`](#kubeinstallservicestop): Stop kubelet service
* [`kubeinstall::system`](#kubeinstallsystem): A short summary of the purpose of this class
* [`kubeinstall::system::bridged_traffic`](#kubeinstallsystembridged_traffic): Load netfilter bridge kernel module
* [`kubeinstall::system::firewall::noop`](#kubeinstallsystemfirewallnoop): Disable firewalld service
* [`kubeinstall::system::overlay`](#kubeinstallsystemoverlay): Load overlay kernel module to support Overlay FS
* [`kubeinstall::system::selinux::noop`](#kubeinstallsystemselinuxnoop): Set selinux in permissive mode
* [`kubeinstall::system::swap`](#kubeinstallsystemswap): Disable swap on the system
* [`kubeinstall::system::sysctl::ip_forward`](#kubeinstallsystemsysctlip_forward): Enable IPv4 forwarding
* [`kubeinstall::system::sysctl::net_bridge`](#kubeinstallsystemsysctlnet_bridge): Setup bridged traffic processing with iptables

### Defined types

* [`kubeinstall::resource::pv`](#kubeinstallresourcepv): Create a PersistentVolume object
* [`kubeinstall::resource::pv::local`](#kubeinstallresourcepvlocal): Local persistent storage volume
* [`kubeinstall::resource::secret`](#kubeinstallresourcesecret): Kubernetes Secrets object
* [`kubeinstall::token_discovery`](#kubeinstalltoken_discovery): Token discovery resource

### Resource types

* [`kubeadm_token`](#kubeadm_token): Bootstrap tokens are a simple bearer token that is meant to be used when creating new clusters or joining new nodes to an existing cluster

### Functions

* [`kubeinstall::discovery_hosts`](#kubeinstalldiscovery_hosts)

### Data types

* [`Kubeinstall::Address`](#kubeinstalladdress)
* [`Kubeinstall::BinaryQuantity`](#kubeinstallbinaryquantity)
* [`Kubeinstall::CACertHash`](#kubeinstallcacerthash)
* [`Kubeinstall::CgroupDriver`](#kubeinstallcgroupdriver)
* [`Kubeinstall::DNSLabel`](#kubeinstalldnslabel)
* [`Kubeinstall::DNSName`](#kubeinstalldnsname)
* [`Kubeinstall::DNSSubdomain`](#kubeinstalldnssubdomain): https://kubernetes.io/docs/concepts/overview/working-with-objects/names#dns-subdomain-names contain no more than 253 characters contain only 
* [`Kubeinstall::DecimalQuantity`](#kubeinstalldecimalquantity)
* [`Kubeinstall::ExponentQuantity`](#kubeinstallexponentquantity)
* [`Kubeinstall::Label`](#kubeinstalllabel): Labels are key/value pairs. Valid annotation keys have two segments: an optional prefix and name, separated by a slash (/). The name segment 
* [`Kubeinstall::LocalPV`](#kubeinstalllocalpv)
* [`Kubeinstall::MatchExpression`](#kubeinstallmatchexpression)
* [`Kubeinstall::MatchExpressionExists`](#kubeinstallmatchexpressionexists)
* [`Kubeinstall::MatchExpressionIn`](#kubeinstallmatchexpressionin)
* [`Kubeinstall::MatchExpressionNum`](#kubeinstallmatchexpressionnum)
* [`Kubeinstall::Metadata`](#kubeinstallmetadata): https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.19/#objectmeta-v1-meta
* [`Kubeinstall::Name`](#kubeinstallname)
* [`Kubeinstall::NodeSelectorTerms`](#kubeinstallnodeselectorterms)
* [`Kubeinstall::Port`](#kubeinstallport): 65535
* [`Kubeinstall::Quantity`](#kubeinstallquantity): https://godoc.org/k8s.io/apimachinery/pkg/api/resource#Quantity  <quantity> ::= <signedNumber><suffix> (Note that <suffix> may be empty, from
* [`Kubeinstall::Range5X`](#kubeinstallrange5x): 1-99999
* [`Kubeinstall::Release`](#kubeinstallrelease)
* [`Kubeinstall::Runtime`](#kubeinstallruntime)
* [`Kubeinstall::Token`](#kubeinstalltoken)
* [`Kubeinstall::TokenTTL`](#kubeinstalltokenttl)
* [`Kubeinstall::Version`](#kubeinstallversion): https://kubernetes.io/docs/setup/release/version-skew-policy/

## Classes

### `kubeinstall`

A description of what this class does

#### Examples

##### 

```puppet
include kubeinstall
```

#### Parameters

The following parameters are available in the `kubeinstall` class.

##### `web_ui_dashboard`

Data type: `Boolean`

Whether to install Web UI on controller node or not

##### `kubernetes_version`

Data type: `Kubeinstall::Version`



##### `container_runtime`

Data type: `Kubeinstall::Runtime`



##### `dockerd_version`

Data type: `String`



##### `containerd_version`

Data type: `String`



##### `crio_version`

Data type: `String`



##### `manage_kernel_modules`

Data type: `Boolean`



##### `manage_sysctl_settings`

Data type: `Boolean`



##### `disable_swap`

Data type: `Boolean`



##### `disable_firewall`

Data type: `Boolean`



##### `disable_selinux`

Data type: `Boolean`



##### `calico_cni_version`

Data type: `String`



##### `join_control_plane`

Data type: `Boolean`



##### `join_token`

Data type: `Optional[Kubeinstall::Token]`



##### `join_ca_cert_hash`

Data type: `Optional[Kubeinstall::CACertHash]`



##### `join_apiserver_address`

Data type: `Optional[Kubeinstall::Address]`



##### `cgroup_driver`

Data type: `Kubeinstall::CgroupDriver`



##### `join_apiserver_port`

Data type: `Integer`



##### `control_plane_endpoint`

Data type: `Optional[Kubeinstall::Address]`



##### `docker_mtu`

Data type: `Optional[Integer]`



##### `network_bridge_ip`

Data type: `Optional[String]`



##### `calico_mtu`

Data type: `Optional[Integer]`



##### `cluster_name`

Data type: `String`



##### `install_calicoctl`

Data type: `Boolean`



##### `calicoctl_version`

Data type: `String`



##### `helm_version`

Data type: `String`



##### `node_name`

Data type: `Stdlib::Fqdn`



Default value: `$facts['networking']['fqdn']`

##### `apiserver_advertise_address`

Data type: `String`



Default value: `$facts['networking']['ip']`

##### `apiserver_bind_port`

Data type: `Integer`



Default value: `$kubeinstall::params::apiserver_bind_port`

##### `cri_socket`

Data type: `Stdlib::Unixpath`



Default value: `$container_runtime`

##### `service_dns_domain`

Data type: `Stdlib::Fqdn`



Default value: `$kubeinstall::params::service_dns_domain`

##### `service_cidr`

Data type: `Stdlib::IP::Address`



Default value: `$kubeinstall::params::service_cidr`

##### `service_node_port_range`

Data type: `String`



Default value: `$kubeinstall::params::service_node_port_range`

##### `dashboard_configuration`

Data type: `Variant[
    Stdlib::HTTPUrl,
    Stdlib::Unixpath
  ]`



Default value: `$kubeinstall::params::dashboard_configuration`

### `kubeinstall::calico::calicoctl`

Installing calicoctl as a binary on a single host
https://docs.projectcalico.org/getting-started/clis/calicoctl/install#installing-calicoctl-as-a-binary-on-a-single-host

#### Examples

##### 

```puppet
include kubeinstall::calico::calicoctl
```

#### Parameters

The following parameters are available in the `kubeinstall::calico::calicoctl` class.

##### `version`

Data type: `String`



Default value: `$kubeinstall::calicoctl_version`

### `kubeinstall::calico::veth_mtu`

Configure Calico MTU
see # https://docs.projectcalico.org/networking/mtu#determine-mtu-size

#### Examples

##### 

```puppet
include kubeinstall::calico::veth_mtu
```

#### Parameters

The following parameters are available in the `kubeinstall::calico::veth_mtu` class.

##### `mtu`

Data type: `Integer`



Default value: `$kubeinstall::calico_mtu`

### `kubeinstall::cluster`

Cluster resources definition, export and import

#### Examples

##### 

```puppet
include kubeinstall::cluster
```

#### Parameters

The following parameters are available in the `kubeinstall::cluster` class.

##### `cluster_role`

Data type: `Optional[Enum['controller', 'worker']]`

Role inside cluster - either 'worker' or 'controller'

Default value: ``undef``

##### `apiserver_address`

Data type: `Kubeinstall::Address`



Default value: `$kubeinstall::apiserver_advertise_address`

##### `apiserver_port`

Data type: `Integer`



Default value: `$kubeinstall::apiserver_bind_port`

##### `cluster_name`

Data type: `String`



Default value: `$kubeinstall::cluster_name`

##### `ca_cert_hash`

Data type: `Optional[Kubeinstall::CACertHash]`



Default value: `$facts['kubeadm_discovery_token_ca_cert_hash']`

##### `local_persistent_volumes`

Data type: `Hash[Kubeinstall::DNSSubdomain, Kubeinstall::LocalPV]`



Default value: `{}`

### `kubeinstall::etcd::backup`

Backing up an etcd cluster

#### Examples

##### 

```puppet
include kubeinstall::etcd::backup
```

### `kubeinstall::install`

A description of what this class does

#### Examples

##### 

```puppet
include kubeinstall::install
```

#### Parameters

The following parameters are available in the `kubeinstall::install` class.

##### `kubernetes_version`

Data type: `Kubeinstall::Version`



Default value: `$kubeinstall::kubernetes_version`

### `kubeinstall::install::calico`

Install Project Calico CNI service

#### Examples

##### 

```puppet
include kubeinstall::install::calico
```

#### Parameters

The following parameters are available in the `kubeinstall::install::calico` class.

##### `version`

Data type: `String`



Default value: `$kubeinstall::calico_cni_version`

##### `node_name`

Data type: `Stdlib::Fqdn`



Default value: `$kubeinstall::node_name`

##### `mtu`

Data type: `Optional[Integer]`



Default value: `$kubeinstall::calico_mtu`

##### `calicoctl`

Data type: `Boolean`



Default value: `$kubeinstall::install_calicoctl`

### `kubeinstall::install::controller`

kubernetes installation on controller node

#### Examples

##### 

```puppet
include kubeinstall::install::controller
```

#### Parameters

The following parameters are available in the `kubeinstall::install::controller` class.

##### `web_ui_dashboard`

Data type: `Boolean`



Default value: `$kubeinstall::web_ui_dashboard`

### `kubeinstall::install::dashboard`

Install Kubernetes dashboard

#### Examples

##### 

```puppet
include kubeinstall::install::dashboard
```

#### Parameters

The following parameters are available in the `kubeinstall::install::dashboard` class.

##### `dashboard_configuration`

Data type: `Variant[
    Stdlib::HTTPUrl,
    Stdlib::Unixpath
  ]`



Default value: `$kubeinstall::dashboard_configuration`

##### `node_name`

Data type: `Stdlib::Fqdn`



Default value: `$kubeinstall::node_name`

### `kubeinstall::install::helm`

Helm client installation

#### Examples

##### 

```puppet
include kubeinstall::install::helm
```

#### Parameters

The following parameters are available in the `kubeinstall::install::helm` class.

##### `version`

Data type: `String`



Default value: `$kubeinstall::helm_version`

##### `helm_install_path`

Data type: `Stdlib::Unixpath`



Default value: `'/usr/local/bin'`

##### `helm_client_only`

Data type: `Boolean`



Default value: ``true``

### `kubeinstall::install::helm_binary`

Helm client installation

#### Examples

##### 

```puppet
include kubeinstall::install::helm_binary
```

#### Parameters

The following parameters are available in the `kubeinstall::install::helm_binary` class.

##### `version`

Data type: `String`



Default value: `$kubeinstall::helm_version`

### `kubeinstall::install::node`

A description of what this class does

#### Examples

##### 

```puppet
include kubeinstall::install::node
```

### `kubeinstall::install::worker`

Kubernetes installation on worker node

#### Examples

##### 

```puppet
include kubeinstall::install::worker
```

### `kubeinstall::kubeadm::config`

A description of what this class does

#### Examples

##### 

```puppet
include kubeinstall::kubeadm::config
```

#### Parameters

The following parameters are available in the `kubeinstall::kubeadm::config` class.

##### `cri_socket`

Data type: `Stdlib::Unixpath`

CRISocket is used to retrieve container runtime info. This information will
be annotated to the Node API object, for later re-use

Default value: `$kubeinstall::cri_socket`

##### `service_node_port_range`

Data type: `Kubeinstall::Range5X`

A port range to reserve for services with NodePort visibility.
Example: '30000-32767'. Inclusive at both ends of the range.

Default value: `$kubeinstall::service_node_port_range`

##### `bootstrap_token`

Data type: `Optional[Kubeinstall::Token]`



Default value: ``undef``

##### `token_ttl`

Data type: `String[2]`



Default value: `'24h0m0s'`

##### `apiserver_advertise_address`

Data type: `Kubeinstall::Address`



Default value: `$kubeinstall::apiserver_advertise_address`

##### `apiserver_bind_port`

Data type: `Integer`



Default value: `$kubeinstall::apiserver_bind_port`

##### `node_name`

Data type: `Stdlib::Fqdn`



Default value: `$kubeinstall::node_name`

##### `cluster_name`

Data type: `String`



Default value: `$kubeinstall::cluster_name`

##### `kubernetes_version`

Data type: `Kubeinstall::Version`



Default value: `$kubeinstall::kubernetes_version`

##### `service_dns_domain`

Data type: `Stdlib::Fqdn`



Default value: `$kubeinstall::service_dns_domain`

##### `service_cidr`

Data type: `Stdlib::IP::Address`



Default value: `$kubeinstall::service_cidr`

##### `control_plane_endpoint`

Data type: `Optional[Kubeinstall::Address]`



Default value: `$kubeinstall::control_plane_endpoint`

##### `cgroup_driver`

Data type: `Kubeinstall::CgroupDriver`



Default value: `$kubeinstall::cgroup_driver`

### `kubeinstall::kubeadm::init_command`

A description of what this class does
see https://kubernetes.io/docs/setup/production-environment/tools/kubeadm/create-cluster-kubeadm/

#### Examples

##### 

```puppet
include kubeinstall::kubeadm::init_command
```

#### Parameters

The following parameters are available in the `kubeinstall::kubeadm::init_command` class.

##### `node_name`

Data type: `Stdlib::Fqdn`



Default value: `$kubeinstall::node_name`

### `kubeinstall::kubeadm::join_command`

Kubernetes kubeadm join command

#### Examples

##### 

```puppet
include kubeinstall::kubeadm::join_command
```

#### Parameters

The following parameters are available in the `kubeinstall::kubeadm::join_command` class.

##### `join_token`

Data type: `Optional[Kubeinstall::Token]`

Use this token for both discovery-token and tls-bootstrap-token in
`kubeadm join` command

Default value: `$kubeinstall::join_token`

##### `join_ca_cert_hash`

Data type: `Optional[Kubeinstall::CACertHash]`

For token-based discovery, validate that the root CA public key matches this
hash. The root CA found during discovery must match this value

Default value: `$kubeinstall::join_ca_cert_hash`

##### `join_apiserver_address`

Data type: `Optional[Kubeinstall::Address]`

API server andpoint address

Default value: `$kubeinstall::join_apiserver_address`

##### `join_apiserver_port`

Data type: `Integer`



Default value: `$kubeinstall::join_apiserver_port`

##### `control_plane`

Data type: `Boolean`



Default value: `$kubeinstall::join_control_plane`

### `kubeinstall::kubeadm::join_config`

Kubernetes kubeadm join command configuration

#### Examples

##### 

```puppet
include kubeinstall::kubeadm::join_config
```

#### Parameters

The following parameters are available in the `kubeinstall::kubeadm::join_config` class.

##### `apiserver_advertise_address`

Data type: `Kubeinstall::Address`

If the node should host a new control plane instance, the IP address the
API Server will advertise it's listening on

Default value: `$kubeinstall::apiserver_advertise_address`

##### `apiserver_bind_port`

Data type: `Integer`

If the node should host a new control plane instance, the port for the API
Server to bind to.

Default value: `$kubeinstall::apiserver_bind_port`

##### `control_plane`

Data type: `Boolean`

Whether to create a new control plane instance on this node

Default value: `$kubeinstall::join_control_plane`

##### `token`

Data type: `Kubeinstall::Token`



##### `ca_cert_hash`

Data type: `Kubeinstall::CACertHash`



##### `apiserver_address`

Data type: `Kubeinstall::Address`



##### `apiserver_port`

Data type: `Integer`



Default value: `$kubeinstall::join_apiserver_port`

##### `cri_socket`

Data type: `Stdlib::Unixpath`



Default value: `$kubeinstall::cri_socket`

##### `node_name`

Data type: `Stdlib::Fqdn`



Default value: `$kubeinstall::node_name`

##### `cgroup_driver`

Data type: `Kubeinstall::CgroupDriver`



Default value: `$kubeinstall::cgroup_driver`

### `kubeinstall::params`

A description of what this class does

#### Examples

##### 

```puppet
include kubeinstall::params
```

### `kubeinstall::profile::controller`

Kubernetes conntroller setup

#### Examples

##### 

```puppet
include kubeinstall::profile::controller
```

#### Parameters

The following parameters are available in the `kubeinstall::profile::controller` class.

##### `helm_client`

Data type: `Boolean`

Whether to install Helm client binary or not

Default value: ``true``

### `kubeinstall::profile::kubernetes`

Base setup for any kubernetes node

#### Examples

##### 

```puppet
include kubeinstall::profile::kubernetes
```

### `kubeinstall::profile::worker`

A description of what this class does

#### Examples

##### 

```puppet
include kubeinstall::profile::worker
```

#### Parameters

The following parameters are available in the `kubeinstall::profile::worker` class.

##### `local_persistent_volumes`

Data type: `Hash[String, Hash]`

Added ability for cluster administrator to setup local persistent volumes
into Kubernetes cluster. This hash should containn only volumes located on
currennt worker node.

Default value: `{}`

### `kubeinstall::repos`

Setup Kubernetes repositories

#### Examples

##### 

```puppet
include kubeinstall::repos
```

### `kubeinstall::repos::crio`

CRI-O repository setup

#### Examples

##### 

```puppet
include kubeinstall::repos::crio
```

#### Parameters

The following parameters are available in the `kubeinstall::repos::crio` class.

##### `kuberel`

Data type: `Kubeinstall::Release`



Default value: `$kubeinstall::kubernetes_release`

### `kubeinstall::runtime`

Kubernetes CRI setup

#### Examples

##### 

```puppet
include kubeinstall::runtime
```

#### Parameters

The following parameters are available in the `kubeinstall::runtime` class.

##### `container_runtime`

Data type: `Kubeinstall::Runtime`



Default value: `$kubeinstall::container_runtime`

##### `docker_decomission`

Data type: `Boolean`



Default value: ``true``

### `kubeinstall::runtime::crio`

CRI-O container runtime installation
see https://kubernetes.io/docs/setup/production-environment/container-runtimes/#cri-o

#### Examples

##### 

```puppet
include kubeinstall::runtime::crio
```

### `kubeinstall::runtime::crio::config`

CRI-O configuration file setup

#### Examples

##### 

```puppet
include kubeinstall::runtime::crio::config
```

### `kubeinstall::runtime::crio::install`

CRI-O packages installation

#### Examples

##### 

```puppet
include kubeinstall::runtime::crio::install
```

#### Parameters

The following parameters are available in the `kubeinstall::runtime::crio::install` class.

##### `crio_version`

Data type: `String`



Default value: `$kubeinstall::crio_version`

### `kubeinstall::runtime::crio::service`

CRI-O service management

#### Examples

##### 

```puppet
include kubeinstall::runtime::crio::service
```

### `kubeinstall::runtime::docker`

Use Docker as container runtime for Kubernetes
see https://kubernetes.io/docs/setup/production-environment/container-runtimes/#docker

#### Examples

##### 

```puppet
include kubeinstall::runtime::docker
```

#### Parameters

The following parameters are available in the `kubeinstall::runtime::docker` class.

##### `network_bridge_ip`

Data type: `Optional[String]`

Default bridge network address (conform to daemon.json bip parameter)

Default value: `$kubeinstall::network_bridge_ip`

##### `dockerd_version`

Data type: `String`



Default value: `$kubeinstall::dockerd_version`

##### `containerd_version`

Data type: `String`



Default value: `$kubeinstall::containerd_version`

##### `mtu`

Data type: `Optional[Integer]`



Default value: `$kubeinstall::docker_mtu`

### `kubeinstall::service`

A description of what this class does

#### Examples

##### 

```puppet
include kubeinstall::service
```

### `kubeinstall::service::stop`

Stop kubelet service

#### Examples

##### 

```puppet
include kubeinstall::service::stop
```

### `kubeinstall::system`

A description of what this class does

#### Examples

##### 

```puppet
include kubeinstall::system
```

#### Parameters

The following parameters are available in the `kubeinstall::system` class.

##### `disable_swap`

Data type: `Boolean`



Default value: `$kubeinstall::disable_swap`

##### `disable_firewall`

Data type: `Boolean`



Default value: `$kubeinstall::disable_firewall`

##### `disable_selinux`

Data type: `Boolean`



Default value: `$kubeinstall::disable_selinux`

### `kubeinstall::system::bridged_traffic`

Load netfilter bridge kernel module

#### Examples

##### 

```puppet
include kubeinstall::system::bridged_traffic
```

#### Parameters

The following parameters are available in the `kubeinstall::system::bridged_traffic` class.

##### `manage_kernel_modules`

Data type: `Boolean`



Default value: `$kubeinstall::manage_kernel_modules`

### `kubeinstall::system::firewall::noop`

Disable firewalld service

#### Examples

##### 

```puppet
include kubeinstall::system::firewall::noop
```

### `kubeinstall::system::overlay`

Load overlay kernel module to support Overlay FS

#### Examples

##### 

```puppet
include kubeinstall::system::overlay
```

#### Parameters

The following parameters are available in the `kubeinstall::system::overlay` class.

##### `manage_kernel_modules`

Data type: `Boolean`



Default value: `$kubeinstall::manage_kernel_modules`

### `kubeinstall::system::selinux::noop`

Set selinux in permissive mode

#### Examples

##### 

```puppet
include kubeinstall::system::selinux::noop
```

### `kubeinstall::system::swap`

Disable swap on the system

#### Examples

##### 

```puppet
include kubeinstall::system::swap
```

### `kubeinstall::system::sysctl::ip_forward`

Enable IPv4 forwarding

#### Examples

##### 

```puppet
include kubeinstall::system::sysctl::ip_forward
```

#### Parameters

The following parameters are available in the `kubeinstall::system::sysctl::ip_forward` class.

##### `manage_sysctl_settings`

Data type: `Boolean`



Default value: `$kubeinstall::manage_sysctl_settings`

### `kubeinstall::system::sysctl::net_bridge`

Setup bridged traffic processing with iptables

#### Examples

##### 

```puppet
include kubeinstall::system::sysctl::net_bridge
```

#### Parameters

The following parameters are available in the `kubeinstall::system::sysctl::net_bridge` class.

##### `manage_sysctl_settings`

Data type: `Boolean`



Default value: `$kubeinstall::manage_sysctl_settings`

## Defined types

### `kubeinstall::resource::pv`

Create a PersistentVolume object
https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.19/#persistentvolume-v1-core

#### Examples

##### 

```puppet
kubeinstall::resource::pv { 'namevar': }
```

#### Parameters

The following parameters are available in the `kubeinstall::resource::pv` defined type.

##### `local_path`

Data type: `Optional[Stdlib::Unixpath]`

The full path to the volume on the node. It can be either a directory or
block device (disk, partition, ...)

Default value: ``undef``

##### `match_expressions`

Data type: `Kubeinstall::NodeSelectorTerms`

A list of node selector requirements by node's labels
correspond to nodeAffinity.required.nodeSelectorTerms.matchExpressions
see https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.19/#nodeselectorterm-v1-core

Default value: `[]`

##### `match_fields`

Data type: `Kubeinstall::NodeSelectorTerms`

A list of node selector requirements by node's fields
correspond to nodeAffinity.required.nodeSelectorTerms.matchFields

Default value: `[]`

##### `volume_storage`

Data type: `Kubeinstall::Quantity`



##### `volume_name`

Data type: `Kubeinstall::DNSName`



Default value: `$title`

##### `volume_mode`

Data type: `Enum['Filesystem', 'Block']`



Default value: `'Filesystem'`

##### `access_modes`

Data type: `Array[Enum['ReadWriteOnce', 'ReadOnlyMany', 'ReadWriteMany']]`



Default value: `['ReadWriteOnce']`

##### `reclaim_policy`

Data type: `Enum['Delete', 'Retain', 'Recycle']`



Default value: `'Delete'`

##### `storage_class_name`

Data type: `Optional[String]`



Default value: ``undef``

### `kubeinstall::resource::pv::local`

Local persistent storage volume

#### Examples

##### 

```puppet
kubeinstall::resource::pv::local { 'namevar': }
```

#### Parameters

The following parameters are available in the `kubeinstall::resource::pv::local` defined type.

##### `volume_storage`

Data type: `String`



##### `path`

Data type: `String`



##### `hostname`

Data type: `Stdlib::Fqdn`



##### `storage_class_name`

Data type: `Optional[String]`



Default value: ``undef``

### `kubeinstall::resource::secret`

Kubernetes Secrets let you store and manage sensitive information
https://kubernetes.io/docs/concepts/configuration/secret/

#### Examples

##### 

```puppet
kubeinstall::resource::secret { 'namevar': }
```

#### Parameters

The following parameters are available in the `kubeinstall::resource::secret` defined type.

##### `metadata`

Data type: `Kubeinstall::Metadata`

Standard object's metadata.
Available fields are annotations, labels, and namespace

Default value: `{}`

##### `data`

Data type: `Hash[
    Kubeinstall::Name,
    Stdlib::Base64
  ]`

Data contains the secret data. Each key must consist of alphanumeric
characters, '-', '_' or '.'. The serialized form of the secret data is a
base64 encoded string, representing the arbitrary (possibly non-string)
data value here

Default value: `{}`

##### `raw_data`

Data type: `Hash[Kubeinstall::Name, String]`

Same as parameter `data` but values should be in raw form and will be
serialized in there

Default value: `{}`

##### `string_data`

Data type: `Hash[Kubeinstall::Name, String]`

stringData allows specifying non-binary secret data in string form. It is
provided as a write-only convenience method. All keys and values are merged
into the data field on write, overwriting any existing values. It is never
output when reading from the API.

Default value: `{}`

##### `object_name`

Data type: `Kubeinstall::DNSName`



Default value: `$title`

##### `type`

Data type: `Enum[
    'Opaque',                              # arbitrary user-defined data
    'kubernetes.io/service-account-token', # service account token
    'kubernetes.io/dockercfg',             # serialized ~/.dockercfg file
    'kubernetes.io/dockerconfigjson',      # serialized ~/.docker/config.json file
    'kubernetes.io/basic-auth',            # credentials for basic authentication
    'kubernetes.io/ssh-auth',              # credentials for SSH authentication
    'kubernetes.io/tls',                   # data for a TLS client or server
    'bootstrap.kubernetes.io/token'        # bootstrap token data
  ]`



Default value: `'Opaque'`

### `kubeinstall::token_discovery`

Resource to export into PuppetDB for distributing
k8s join credentials among cluster nodes

#### Examples

##### 

```puppet
kubeinstall::token_discovery { 'o9o8vw.fe02deotcm0dv8z5': }
```

#### Parameters

The following parameters are available in the `kubeinstall::token_discovery` defined type.

##### `ca_cert_hash`

Data type: `Kubeinstall::CACertHash`



##### `token`

Data type: `Kubeinstall::Token`



Default value: `$name`

##### `apiserver_address`

Data type: `Kubeinstall::Address`



Default value: `$kubeinstall::apiserver_advertise_address`

##### `apiserver_port`

Data type: `Integer`



Default value: `$kubeinstall::apiserver_bind_port`

##### `cluster_name`

Data type: `String`



Default value: `$kubeinstall::cluster_name`

## Resource types

### `kubeadm_token`

Bootstrap tokens are a simple bearer token that is meant to be used when creating new clusters or joining new nodes to an existing cluster

#### Properties

The following properties are available in the `kubeadm_token` type.

##### `auth_extra_groups`

Valid values: `%r{^system:bootstrappers:[a-z0-9:-]{0,255}[a-z0-9]$}`

Extra groups to authenticate the token as

##### `description`

Human readable description

##### `ensure`

Valid values: `present`, `absent`

Create or remove token.

Default value: `present`

##### `id`

Valid values: `%r{^[a-z0-9]{6}$}`

Token ID

##### `secret`

Valid values: `%r{^[a-z0-9]{6}$}`

Token Secret

##### `ttl`

Valid values: `%r{^([0-9]+h)?([1-5]?[0-9]m)?([1-5]?[0-9]s)?$}`, `0`, `0`

Controls the expiry of the token

Default value: `24h0m0s`

#### Parameters

The following parameters are available in the `kubeadm_token` type.

##### `bootstrap_authentication`

Valid values: ``true``, ``false``, `yes`, `no`

Indicates that the token can be used to authenticate to the API server as a bearer token

Default value: ``true``

##### `bootstrap_signing`

Valid values: ``true``, ``false``, `yes`, `no`

Indicates that the token may be used to sign the cluster-info ConfigMap

Default value: ``true``

##### `name`

Valid values: `%r{^(bootstrap-token-)?[a-z0-9]{6}$}`, `default`

namevar

Token Name

##### `provider`

The specific backend to use for this `kubeadm_token` resource. You will seldom need to specify this --- Puppet will
usually discover the appropriate provider for your platform.

## Functions

### `kubeinstall::discovery_hosts`

Type: Ruby 4.x API

The kubeinstall::discovery_hosts function.

#### `kubeinstall::discovery_hosts(String $lookup_type, Optional[Array] $equery)`

The kubeinstall::discovery_hosts function.

Returns: `Any`

##### `lookup_type`

Data type: `String`



##### `equery`

Data type: `Optional[Array]`



#### `kubeinstall::discovery_hosts(String $lookup_type, String $lookup_param, Optional[Array] $equery)`

The kubeinstall::discovery_hosts function.

Returns: `Any`

##### `lookup_type`

Data type: `String`



##### `lookup_param`

Data type: `String`



##### `equery`

Data type: `Optional[Array]`



#### `kubeinstall::discovery_hosts(String $lookup_type, Array[String] $lookup_param, Optional[Array] $equery)`

The kubeinstall::discovery_hosts function.

Returns: `Any`

##### `lookup_type`

Data type: `String`



##### `lookup_param`

Data type: `Array[String]`



##### `equery`

Data type: `Optional[Array]`



## Data types

### `Kubeinstall::Address`

The Kubeinstall::Address data type.

Alias of `Variant[Stdlib::Fqdn, Stdlib::IP::Address::Nosubnet]`

### `Kubeinstall::BinaryQuantity`

The Kubeinstall::BinaryQuantity data type.

Alias of `Pattern[/^[+-]?([0-9]+(\.[0-9]*)?|\.[0-9]+)[KMGTPE]i$/]`

### `Kubeinstall::CACertHash`

The Kubeinstall::CACertHash data type.

Alias of `Pattern[/^sha256:[0-9a-f]{64}$/]`

### `Kubeinstall::CgroupDriver`

The Kubeinstall::CgroupDriver data type.

Alias of `Enum['systemd', 'cgroupfs']`

### `Kubeinstall::DNSLabel`

The Kubeinstall::DNSLabel data type.

Alias of `Pattern[/^[a-z0-9]([a-z0-9-]{0,61}[a-z0-9])?$/]`

### `Kubeinstall::DNSName`

The Kubeinstall::DNSName data type.

Alias of `Pattern[/^([a-z0-9]([a-z0-9-]{0,61}[a-z0-9])?\.)*[a-z0-9]([a-z0-9-]{0,61}[a-z0-9])?$/]`

### `Kubeinstall::DNSSubdomain`

https://kubernetes.io/docs/concepts/overview/working-with-objects/names#dns-subdomain-names
contain no more than 253 characters
contain only lowercase alphanumeric characters, '-' or '.'
start with an alphanumeric character
end with an alphanumeric character

Alias of `Pattern[/^[a-z0-9]([.a-z0-9-]{0,251}[a-z0-9])?$/]`

### `Kubeinstall::DecimalQuantity`

The Kubeinstall::DecimalQuantity data type.

Alias of `Pattern[/^[+-]?([0-9]+(\.[0-9]*)?|\.[0-9]+)[mkMGTPE]?$/]`

### `Kubeinstall::ExponentQuantity`

The Kubeinstall::ExponentQuantity data type.

Alias of `Pattern[/^[+-]?([0-9]+(\.[0-9]*)?|\.[0-9]+)[eE][+-]?([0-9]+(\.[0-9]*)?|\.[0-9]+)$/]`

### `Kubeinstall::Label`

Labels are key/value pairs. Valid annotation keys have two segments: an
optional prefix and name, separated by a slash (/). The name segment is
required and must be 63 characters or less, beginning and ending with an
alphanumeric character ([a-z0-9A-Z]) with dashes (-), underscores (_),
dots (.), and alphanumerics between. The prefix is optional. If specified,
the prefix must be a DNS subdomain: a series of DNS labels separated by
dots (.), not longer than 253 characters in total, followed by a slash (/).

Alias of `Pattern[/^([a-z0-9]([.a-z0-9-]{0,251}[a-z0-9])?\/)?[a-z0-9A-Z]([_.a-z0-9A-Z-]{0,61}[a-z0-9A-Z])?$/]`

### `Kubeinstall::LocalPV`

The Kubeinstall::LocalPV data type.

Alias of `Struct[{
  path               => Stdlib::Unixpath,
  volume_storage     => Kubeinstall::Quantity,
  name               => Optional[Kubeinstall::DNSName],
  hostname           => Optional[Stdlib::Fqdn],
  storage_class_name => Optional[String],
}]`

### `Kubeinstall::MatchExpression`

The Kubeinstall::MatchExpression data type.

Alias of `Variant[Kubeinstall::MatchExpressionIn, Kubeinstall::MatchExpressionExists, Kubeinstall::MatchExpressionNum]`

### `Kubeinstall::MatchExpressionExists`

The Kubeinstall::MatchExpressionExists data type.

Alias of `Struct[{
  key      => String,
  operator => Enum['Exists', 'DoesNotExist'],
  values   => Array[String, 0, 0],
}]`

### `Kubeinstall::MatchExpressionIn`

The Kubeinstall::MatchExpressionIn data type.

Alias of `Struct[{
  key      => String,
  operator => Enum['In', 'NotIn'],
  values   => Array[String, 1],
}]`

### `Kubeinstall::MatchExpressionNum`

The Kubeinstall::MatchExpressionNum data type.

Alias of `Struct[{
  key      => String,
  operator => Enum['Gt', 'Lt'],
  values   => Array[Pattern[/^[0-9]+$/], 1, 1],
}]`

### `Kubeinstall::Metadata`

https://kubernetes.io/docs/reference/generated/kubernetes-api/v1.19/#objectmeta-v1-meta

Alias of `Struct[{
  annotations => Optional[Hash[Kubeinstall::Label, String]],
  labels      => Optional[
                    Hash[
                      Kubeinstall::Label,
                      Variant[Enum[''], Kubeinstall::DNSLabel]
                    ]
                  ],
  namespace   => Optional[Kubeinstall::DNSLabel],
}]`

#### Parameters

The following parameters are available in the `Kubeinstall::Metadata` data type.

##### `annotations`

Annotations is an unstructured key value map stored with a resource that
may be set by external tools to store and retrieve arbitrary metadata.

### `Kubeinstall::Name`

The Kubeinstall::Name data type.

Alias of `Pattern[/^[_.a-z0-9A-Z-]+$/]`

### `Kubeinstall::NodeSelectorTerms`

The Kubeinstall::NodeSelectorTerms data type.

Alias of `Array[Kubeinstall::MatchExpression]`

### `Kubeinstall::Port`

65535

Alias of `Pattern[/^(655([0-2][0-9]|3[0-5])|65[0-4][0-9]{2}|6[0-4][0-9]{3}|[1-5][0-9]{4}|[1-9][0-9]{,3})$/]`

### `Kubeinstall::Quantity`

https://godoc.org/k8s.io/apimachinery/pkg/api/resource#Quantity

<quantity> ::= <signedNumber><suffix> (Note that <suffix> may be empty, from the "" case in <decimalSI>.)
<digit> ::= 0 \| 1 \| …​ \| 9
<digits> ::= <digit> \| <digit><digits>
<number> ::= <digits> \| <digits>.<digits> \| <digits>. \| .<digits>
<sign> ::= "+" \| "-"
<signedNumber> ::= <number> \| <sign><number>
<suffix> ::= <binarySI> \| <decimalExponent> \| <decimalSI>
<binarySI> ::= Ki \| Mi \| Gi \| Ti \| Pi \| Ei (International System of units; See: http://physics.nist.gov/cuu/Units/binary.html)
<decimalSI> ::= m \| "" \| k \| M \| G \| T \| P \| E (Note that 1024 = 1Ki but 1000 = 1k; I didn't choose the capitalization.)
<decimalExponent> ::= "e" <signedNumber> \| "E" <signedNumber>

Alias of `Variant[Kubeinstall::BinaryQuantity, Kubeinstall::DecimalQuantity, Kubeinstall::ExponentQuantity]`

### `Kubeinstall::Range5X`

1-99999

Alias of `Pattern[/^[1-9][0-9]{,4}-[1-9][0-9]{,4}$/]`

### `Kubeinstall::Release`

The Kubeinstall::Release data type.

Alias of `Variant[Pattern[/^1\.1[6-9]/], Pattern[/^1\.2[01]/]]`

### `Kubeinstall::Runtime`

The Kubeinstall::Runtime data type.

Alias of `Enum['containerd', 'cri-o', 'docker']`

### `Kubeinstall::Token`

The Kubeinstall::Token data type.

Alias of `Pattern[/^[a-z0-9]{6}.[a-z0-9]{16}$/]`

### `Kubeinstall::TokenTTL`

The Kubeinstall::TokenTTL data type.

Alias of `Pattern[/^([0-9]+h)?([0-5]?[0-9]m)?([0-5]?[0-9]s)?$/]`

### `Kubeinstall::Version`

https://kubernetes.io/docs/setup/release/version-skew-policy/

Alias of `Variant[Pattern[/^1\.1[6-9]\.[0-9]+/], Pattern[/^1\.2[01]\.[0-9]+/]]`

